<?php

namespace Controller;

use Service\DeleteCascadeService;
use Service\Manager\Mongo\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class DefaultRelations extends Crud{

    protected $dataSourceName = "defaultRelations";

    protected $defaultRelationsService;

    public function __construct(Manager $mongoManager, DeleteCascadeService $deleteCascadeService, \Service\DefaultRelations $defaultRelationsService) {
        parent::__construct($mongoManager, $deleteCascadeService);
        $this->defaultRelationsService = $defaultRelationsService;
    }

    public function updateOrInsertDefault(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $persistedRows = $this->defaultRelationsService->updateOrInsertDefaultRelation($row);
            $nrPersistedRows = count($persistedRows);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            $response->addNotification(new DTO\Response\Notification("{$nrPersistedRows} relations subscribed with success"));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}