<?php

namespace Controller;

use Service\zmartAccessProfile as ZmartAccessProfileService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\Manager;


class ZmartAccessProfile{

    protected $dataSourceName = "zmartAccessProfile";

    /** @var ZmartAccessProfileService $accessProfileService */
    protected $accessProfileService;


    public function __construct(ZmartAccessProfileService $accessProfileService) {
        $this->accessProfileService = $accessProfileService;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $request->getFilterCriteria()->getConditions();
        $page = $request->getFilterCriteria()->getPage();
        $pageSize = $request->getFilterCriteria()->getPageSize();
        try {
            $accessProfile = $this->accessProfileService->find($conditions, $page, $pageSize);
            $response->addDataSet(new DataSet('zmartAccessProfile', $accessProfile));
        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
        }
    }


}