<?php
namespace Service\Mail;

use Service\Mail\BuildMail;

class DataSourceMail {
 
    private $buildMail;

    public function __construct(BuildMail $buildMail){
        $this->buildMail = $buildMail;
        $this->baseDir = __DIR__.DIRECTORY_SEPARATOR.'EmailTemplates'.DIRECTORY_SEPARATOR;
    }
                                     
    public function sendMessageMail($addressee, $name, $message, $dataSourceName){
        $senderName = "zmart@teknisa.com";
        $date = date("d/m/Y");
        $to[0] = array('EMAIL' => $addressee);
        $subject = "Erro de importação";
        $previousMessage = $this->buildMessage($name, $message, $dataSourceName, $date);

        $message = $this->buildMail->setMessageMail($previousMessage);
        $this->buildMail->sendHtml($to, $subject, $message, $senderName);
    }
    
    public function buildMessage($name, $message, $dataSourceName, $date){
        $replacedContents = $this->buildMail->setMessage('error_import_dataSource.html');
        $replacedContents = str_replace('%name%', $name, $replacedContents);
        $replacedContents = str_replace('%error%', $message, $replacedContents);
        $replacedContents = str_replace('%dataSourceName%', $dataSourceName, $replacedContents);
        $replacedContents = str_replace('%data%', $date, $replacedContents);
        return $replacedContents;
    }
}