/**
 * @module actions
 * 
 * @property {String}  id           - Action id.
 * @property {String}  name         - Action name.
 * @property {String}  label        - Action label.
 * @property {String}  icon         - Action icon.
 * @property {String}  tooltip      - Tooltip text.
 * @property {String}  showAsAction - Defines the location and visibility of the action by arguments. <a href="../jsDocs/module-actions.showAsAction.html"> See more</a>
 * @property {Boolean} isVisible    - Defines the action visibility.
 * @property {Boolean} readOnly     - Defines if the action is only to read.
 * @property {Object}  events       - Defines the events triggered by the action.
 * @example
    
    "actions": [

        //Simple action example
        {
            "id": "3935187193502408010477",
            "name": "edit",
            "label": "Edit",
            "showAsAction": "always",
            "events": [
                {
                    "id": "393518719534273360398",
                    "name": "ActionEvent",
                    "code": "args.owner.widget.edit();"
                }
            ]
        }

    ]
 */ 