/**
 * Names of events for fields.
 * @namespace   field
 * @memberOf    module:events
 * @implements  {events}
 * 
 * @property {String} FieldOnChange             - Triggered on a value change of the field.
 * @property {String} FieldOnInput              - Triggered on a input of the value.
 * @property {String} FieldOnCancel             - Triggered when cancelling an edition.
 * @property {String} FieldOnAdd                - Triggered on adding a new row to a select's widget.
 * @property {String} FieldOnConfirm            - Triggered on confirming a edition.
 * @property {String} FieldOnClick              - Triggered when clicking on the field.
 * @property {String} FieldOnBlur               - Triggered when unfocusing the field.
 * @property {String} FieldOnKeypress           - Triggered when clicking a key on the field.
 * @property {String} FieldOnKeyup              - Triggered when releasing a key on the field.
 * @property {String} FieldOnKeydown            - Triggered when pressing a key on the field.
 * @property {String} FieldAfterMoveRow         - Triggered after changing the field's current row.
 * @property {String} FieldBeforeMoveRow        - Triggered before changing the field's current row.
 * @property {String} FieldOnFocus              - Triggered when focusing the field.
 * @property {String} FieldBeforeSelectOpen     - Triggered before openning the select's widget.
 * @property {String} FieldAfterSelectOpen      - Triggered after openning the select's widget.
 * @property {String} FieldAfterSelectFile      - Triggered after selecting a file on the file uploader.
 * @property {String} FieldAfterDeselectFile    - Triggered after deselecting a file on the file uploader.
 * @property {String} FieldInlineEdit           - Triggered when starting a inline edition on field's widget.
 * @property {String} FieldOnNewColor           - Triggered when changing the color.
 */