(function () {
	var ZeedhiDirectives = angular.module('ZeedhiDirectives');
	ZeedhiDirectives.directive('zhCrosstab', zhCrosstab);

	function zhCrosstab(templateManager, ZHPromise, $timeout) {

		var linkFunction = function (scope, element, attrs) {
			function resizeCrosstabRows() {
				var rowHeight;

				element.find(".body-content .tr").each(function(index, tr) {
					tr = $(tr);
					rowHeight = 0;
					tr.find(".td").each(function(index, td) {
						rowHeight = Math.max(rowHeight, $(td).height());
					});

					tr.height(rowHeight);
					tr.find(".td").height(rowHeight);
				});

				scope.resizeGridColumns();
			}

			scope.resizeCrosstabContent = function() {
				if (scope.widget.htmlContent) {
					$timeout(resizeCrosstabRows, 0);
				} else {
					scope.resizeGridColumns();					
				}
			};
		};

		return {
			restrict: 'A',
			link: linkFunction
		};
	}
})();