<?php
namespace Teknisa\Model\Teknisa\Repositories;


class Contratolinp extends \Doctrine\ORM\EntityRepository {
    
    public function findBillingReferringToMonth($clientId)
    {
        $query = <<<SQL
            SELECT DISTINCT CL.DTMESAPURLINP,
                   TO_CHAR(CL.DTMESAPURLINP,'DD/MM/YYYY') AS DTMESAPURFAS,
                   TO_CHAR(CL.DTMESAPURLINP,'MONTH/YYYY' ) AS DTFATURAMENTO
              FROM CONTRATOLINPAPU CL
             WHERE CL.CDCLIENTE = :P_CDCLIENTE
               AND EXISTS (SELECT AP.*
                             FROM APURFATUFAS AP
                            WHERE AP.CDCLIENTE = CL.CDCLIENTE
                              AND AP.CDLINPCLIE = CL.CDLINPCLIE
                              AND AP.IDAPURFATFAS = '6' -- MANUTENÇÃO E LOCAÇÃO
                              AND AP.IDSTAPFATFAS = 'R') -- FATURADA
             ORDER BY CL.DTMESAPURLINP DESC
SQL;
        $params = array('P_CDCLIENTE' => $clientId);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        
    }
    
    public function findOpenBillings($clientId)
    {
        $query = <<<SQL
            SELECT CAIXAS, CDCLIENTE, CDGRUPONFLINPC, CDLINPCLIE, CDLINPCLIEINFOR, DTFVIGVRLINP, DTHOJE, DTIVIGVRLINP,
                   IDMPROCLINPC || '/' || IDLPROCLINPC AS MODE_LOCATION, IDTIPLINPC, IDTIPLINPC AS IDTIPLINPC_FORM, NRUSUALINPC, QTATIVAS, QTMINIMAFATLINP,
                   QTSISTEMAS, QTVALIDAS, VRLICENCUSOLINP, VRMENSALIDALINP, '' AS DTFATURAMENTO, ' ' AS GROUPED,
                   CASE WHEN (QTMINIMAFATLINP > QTVALIDAS )
                        THEN QTMINIMAFATLINP * VRMENSALIDALINP
                        ELSE QTVALIDAS * VRMENSALIDALINP
                    END AS VRTOTALMENSAL,
                    (NMLINPCLIE || ' - ' || '(' ||
                    (SELECT RTRIM(XMLAGG(XMLELEMENT(e,SI.SGSISTEMA ,', ').EXTRACT('//text()')).GetClobVal(),', ')
                             FROM SISTCONTLINP SC, SISTEMA SI, PROCOMERCI PR
                             WHERE SC.CDCLIENTE = :P_CDCLIENTE
                             AND SC.CDLINPCLIE = CA.CDLINPCLIE
                             AND SI.CDSISTEMA = SC.CDSISTEMA
                             AND PR.CDPROCOMERCI = SI.CDPROCOMERCI) || ')') AS NMLINPCLIE
              FROM (SELECT CX.CAIXAS, T.*
                      FROM TABLE (LINHA_PRODUTO_FAT (:P_CDCLIENTE)) T,
                           (SELECT CO.CDCLIENTE, CO.CDLINPCLIE, CO.NMLINPCLIE, NVL(CN.TOTAL,0) AS CAIXAS
                              FROM CONTRATOLINP CO,
                                   (SELECT SUM(C.TOTAL) AS TOTAL, L.CDLINPCLIE
                                      FROM LINPLUSO L,
                                           (SELECT CDCLIENTE, NRLICENCAUSO, COUNT(CDCAIXALUSO) AS TOTAL
                                              FROM CAIXALUSO
                                             WHERE CDCLIENTE= :P_CDCLIENTE
                                          GROUP BY CDCLIENTE, NRLICENCAUSO
                                           )C
                                     WHERE L.CDCLIENTE    = C.CDCLIENTE
                                       AND L.NRLICENCAUSO = C.NRLICENCAUSO
                                  GROUP BY L.CDLINPCLIE
                                   ) CN
                              WHERE CO.CDLINPCLIE = CN.CDLINPCLIE(+)
                                AND CO.CDCLIENTE = :P_CDCLIENTE
                           ) CX
             WHERE T.CDCLIENTE = CX.CDCLIENTE
               AND T.CDLINPCLIE = CX.CDLINPCLIE
          ORDER BY DECODE(T.IDTIPLINPC, 'M', 1, 'L', 1, 'P', 2, 'A', 2, NULL, 0), T.NMLINPCLIE) CA
SQL;
        $params = array('P_CDCLIENTE' => $clientId);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
    public function findMonthBilling($billingDate, $clientId)
    {
        $query = <<<SQL
            SELECT CLA.CDCLIENTE, CLA.CDLINPCLIE, CLA.IDTIPLINPCAPUR AS IDTIPLINPC, CLA.IDTIPLINPCAPUR AS IDTIPLINPC_FORM,
                   QTS.QTSISTEMAS, CLA.NRUSUALINPAPUR AS NRUSUALINPC, CLA.IDMPROCLINPAPUR || '/' || CLA.IDLPROCLINPAPUR AS MODE_LOCATION, 
                   CLA.VRLICENCUSOAPUR AS VRLICENCUSOLINP, NVL(QTA.QTATIVAS,0) QTATIVAS , NVL(QTV.QTVALIDAS,0) QTVALIDAS,
                   NVL(CLA.QTMINIMAFATAPUR,0) QTMINIMAFATLINP, CLA.VRMENSALIDAAPUR AS VRMENSALIDALINP,'$billingDate' AS DTFATURAMENTO,
                   ' ' AS GROUPED,
                   CASE WHEN (NVL(CLA.QTMINIMAFATAPUR,0) > NVL(QTV.QTVALIDAS,0))
                        THEN NVL(CLA.QTMINIMAFATAPUR,0) * CLA.VRMENSALIDAAPUR
                        ELSE NVL(QTV.QTVALIDAS,0) * CLA.VRMENSALIDAAPUR
                    END AS VRTOTALMENSAL,
                    (CLA.NMLINPCLIEAPUR || ' - ' || '(' ||
                    (SELECT RTRIM(XMLAGG(XMLELEMENT(e,SI.SGSISTEMA ,', ').EXTRACT('//text()')).GetClobVal(),', ')
                             FROM SISTCONTLINP SC, SISTEMA SI, PROCOMERCI PR
                             WHERE SC.CDCLIENTE = :P_CDCLIENTE
                             AND SC.CDLINPCLIE = CLA.CDLINPCLIE
                             AND SI.CDSISTEMA = SC.CDSISTEMA
                             AND PR.CDPROCOMERCI = SI.CDPROCOMERCI) || ')') AS NMLINPCLIE
              FROM CONTRATOLINPAPU CLA,
                   (SELECT SI.CDCLIENTE, SI.CDLINPCLIE, COUNT(*) AS QTSISTEMAS
                      FROM SISTCONTLINPAPU SI
                     WHERE SI.CDCLIENTE = :P_CDCLIENTE
                       AND SI.DTMESAPURLINP = :P_DATA
                  GROUP BY SI.CDCLIENTE, SI.CDLINPCLIE) QTS,
                   (SELECT LL.CDCLIENTE, LL.CDLINPCLIE, COUNT(*) AS QTATIVAS
                      FROM CONTRATOLINPAPU CL, LINPLUSOAPUR LL
                     WHERE LL.CDCLIENTE = :P_CDCLIENTE
                       AND LL.DTMESAPURLINP = :P_DATA
                       AND LL.IDLUSOATIVAPUR = 'S'
                       AND CL.CDCLIENTE = LL.CDCLIENTE
                       AND CL.CDLINPCLIE = LL.CDLINPCLIE
                       AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CL.IDTIPLINPCAPUR IN ('M', 'L')
                     GROUP BY LL.CDCLIENTE, LL.CDLINPCLIE
                     UNION ALL
                    SELECT LL.CDCLIENTE, LL.CDLINPCLIE, COUNT(*) AS QTATIVAS
                      FROM CONTRATOLINPAPU CL, CAIXALUSOAPUR CX, LINPLUSOAPUR LL
                     WHERE LL.CDCLIENTE = :P_CDCLIENTE
                       AND LL.DTMESAPURLINP = :P_DATA
                       AND LL.IDLUSOATIVAPUR = 'S'
                       AND CL.CDCLIENTE = LL.CDCLIENTE
                       AND CL.CDLINPCLIE = LL.CDLINPCLIE
                       AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CL.IDTIPLINPCAPUR IN ('P', 'A')
                       AND CX.CDCLIENTE = LL.CDCLIENTE
                       AND CX.CDLINPCLIE = LL.CDLINPCLIE
                       AND CX.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
                     GROUP BY LL.CDCLIENTE, LL.CDLINPCLIE) QTA,
                   (SELECT LL.CDCLIENTE, LL.CDLINPCLIE, COUNT(*) AS QTVALIDAS
                      FROM CONTRATOLINPAPU CL, LINPLUSOAPUR LL 
                     WHERE LL.CDCLIENTE = :P_CDCLIENTE
                       AND LL.DTMESAPURLINP = :P_DATA
                       AND (LL.IDLUSOATIVAPUR = 'S' OR LL.DTVALIPERSAPUR > ADD_MONTHS(LAST_DAY(TRUNC(LL.DTMESAPURLINP)), -1))
                       AND CL.CDCLIENTE = LL.CDCLIENTE
                       AND CL.CDLINPCLIE = LL.CDLINPCLIE
                       AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CL.IDTIPLINPCAPUR IN ('M', 'L')
                     GROUP BY LL.CDCLIENTE, LL.CDLINPCLIE
                     UNION ALL
                    SELECT LL.CDCLIENTE, LL.CDLINPCLIE, COUNT(*) AS QTVALIDAS
                      FROM CONTRATOLINPAPU CL, CAIXALUSOAPUR CX, LINPLUSOAPUR LL
                     WHERE LL.CDCLIENTE = :P_CDCLIENTE
                       AND LL.DTMESAPURLINP = :P_DATA
                       AND (LL.IDLUSOATIVAPUR = 'S' OR CX.DTVALIPERCXAPUR > ADD_MONTHS(LAST_DAY(TRUNC(CX.DTMESAPURLINP)), -1))
                       AND CL.CDCLIENTE = LL.CDCLIENTE
                       AND CL.CDLINPCLIE = LL.CDLINPCLIE
                       AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CL.IDTIPLINPCAPUR IN ('P', 'A')
                       AND CX.CDCLIENTE = LL.CDCLIENTE
                       AND CX.CDLINPCLIE = LL.CDLINPCLIE
                       AND CX.DTMESAPURLINP = LL.DTMESAPURLINP
                       AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
                     GROUP BY LL.CDCLIENTE, LL.CDLINPCLIE) QTV
             WHERE CLA.CDCLIENTE = :P_CDCLIENTE
               AND CLA.DTMESAPURLINP = :P_DATA
               AND QTS.CDCLIENTE (+) = CLA.CDCLIENTE
               AND QTS.CDLINPCLIE (+) = CLA.CDLINPCLIE
               AND QTA.CDCLIENTE (+) = CLA.CDCLIENTE
               AND QTA.CDLINPCLIE (+) = CLA.CDLINPCLIE
               AND QTV.CDCLIENTE (+) = CLA.CDCLIENTE
               AND QTV.CDLINPCLIE (+) = CLA.CDLINPCLIE
             ORDER BY DECODE(CLA.IDTIPLINPCAPUR, 'M', 1, 'L', 1, 'P', 2, 'A', 2), CLA.NMLINPCLIEAPUR
SQL;
        $params = array(
            'P_CDCLIENTE' => $clientId,
            'P_DATA' => $billingDate
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
}