<?php
namespace Teknisa\Model\Geral\Repositories;

use HCM\Util\Repositories;

class Estruturam extends \Doctrine\ORM\EntityRepository {
    
    public function retornaEstrutura($nrorg, $nrestruturam, $dtmescompetenc){
    
	$params = array('nrestruturam' => $nrestruturam, 'nrorg'=>$nrorg, 'dtmescompetenc' => $dtmescompetenc);
    $estruturam =  '\Teknisa\Model\Geral\Entities\Estruturam';

$sql = <<<SQL
SELECT s FROM $estruturam s
WHERE s.nrorg = :nrorg
    and s.nrestruturam = :nrestruturam    
    and s.dtinivigencia <= :dtmescompetenc
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result[0];
    }
    
    public function getVincSalAbaixo5SM( $nrestruturam, $nrorg, $ano)
    {
        $ultdiano = '31/12/'.$ano;
        $primdiano = '01/01/'.$ano;
        $gpe_vinculom = Repositories::GPE_VINCULOM;
        $gpe_vinculoh = Repositories::GPE_VINCULOH;
        $gpe_altesalario = Repositories::GPE_ALTESALARIO;
        $fpa_valorreferenciah = Repositories::FPA_VALORREFERENCIAH;
        $sql = <<<SQL
    select 
        count(vm.nrvinculom) qtd
    from $gpe_vinculom vm
    inner join $gpe_vinculoh vh
        WITH vm.nrvinculom = vh.nrvinculom
        and vm.nrorg = vh.nrorg
    inner join $gpe_altesalario asl
        WITH vm.nrorg = asl.nrorg
        and vm.nrvinculom = asl.nrvinculom
    where 
            vm.nrtipovinculom in (1, 7, 9)
        and vm.nrorg = :nrorg
        and vm.dtadmissaovinc <= :ultdiano
        and vh.nrestrutlegal = :nrestruturam
        and (vm.dtrescisaovinc is null
            or vm.dtrescisaovinc >= :primdiano)
        and vh.dtmescompetenc = (select max(mvh.dtmescompetenc)
                                           from $gpe_vinculoh mvh
                                           where mvh.nrorg = vh.nrorg
                                              and mvh.nrvinculom = vh.nrvinculom
                                              and mvh.dtmescompetenc <= :ultdiano)
        and asl.dtaltesalario = ( select max(masl.dtaltesalario) dtaltesalario
                                              from $gpe_altesalario masl
                                              where masl.nrorg = asl.nrorg
                                                  and masl.nrvinculom = asl.nrvinculom
                                                  and masl.dtaltesalario <= :ultdiano)
        and asl.vrsalario < ( select (fh.vrreferencia*5)
                        from $fpa_valorreferenciah fh
                        where fh.nrvalorreferenciam = 1
                            and fh.dtmescompetenc = (select max(mfh.dtmescompetenc)
                                                from $fpa_valorreferenciah mfh
                                                where fh.nrvalorreferenciam = mfh.nrvalorreferenciam
                                                    and mfh.dtmescompetenc <= :ultdiano))
    group by vm.nrorg,
    vh.nrestrutlegal
SQL;

     
        $params = array(
            'ultdiano' => $ultdiano,
            'primdiano' => $primdiano,
            'nrestruturam' => $nrestruturam,
            'nrorg' => $nrorg
        
        );
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return ($result)?$result[0]:false;
    }
    
    public function getVincSalAcima5SM( $nrestruturam, $nrorg, $ano)
    {
        $ultdiano = '31/12/'.$ano;
        $primdiano = '01/01/'.$ano;
        $gpe_vinculom = Repositories::GPE_VINCULOM;
        $gpe_vinculoh = Repositories::GPE_VINCULOH;
        $gpe_altesalario = Repositories::GPE_ALTESALARIO;
        $fpa_valorreferenciah = Repositories::FPA_VALORREFERENCIAH;
        $sql = <<<SQL
    select 
        count(vm.nrvinculom) qtd
    from $gpe_vinculom vm
    inner join $gpe_vinculoh vh
        WITH vm.nrvinculom = vh.nrvinculom
        and vm.nrorg = vh.nrorg
    inner join $gpe_altesalario asl
        WITH vm.nrorg = asl.nrorg
        and vm.nrvinculom = asl.nrvinculom
    where 
            vm.nrtipovinculom in (1, 7, 9)
        and vm.nrorg = :nrorg
        and vm.dtadmissaovinc <= :ultdiano
        and vh.nrestrutlegal = :nrestruturam
        and (vm.dtrescisaovinc is null
            or vm.dtrescisaovinc >= :primdiano)
        and vh.dtmescompetenc = (select max(mvh.dtmescompetenc)
                                           from $gpe_vinculoh mvh
                                           where mvh.nrorg = vh.nrorg
                                              and mvh.nrvinculom = vh.nrvinculom
                                              and mvh.dtmescompetenc <= :ultdiano)
        and asl.dtaltesalario = ( select max(masl.dtaltesalario) dtaltesalario
                                              from $gpe_altesalario masl
                                              where masl.nrorg = asl.nrorg
                                                  and masl.nrvinculom = asl.nrvinculom
                                                  and masl.dtaltesalario <= :ultdiano)
        and asl.vrsalario > ( select (fh.vrreferencia*5)
                        from $fpa_valorreferenciah fh
                        where fh.nrvalorreferenciam = 1
                            and fh.dtmescompetenc = (select max(mfh.dtmescompetenc)
                                                from $fpa_valorreferenciah mfh
                                                where fh.nrvalorreferenciam = mfh.nrvalorreferenciam
                                                    and mfh.dtmescompetenc <= :ultdiano))
    group by vm.nrorg,
    vh.nrestrutlegal
SQL;

     
        $params = array(
            'ultdiano' => $ultdiano,
            'primdiano' => $primdiano,
            'nrestruturam' => $nrestruturam,
            'nrorg' => $nrorg
        
        );
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return ($result)?$result[0]:false;
    }

    public function quantFuncPorPat( $nrestruturam, $nrorg, $nrtiposervpat, $ano)
    {
        $ultdiano = '31/12/'.$ano;
        $primdiano = '01/01/'.$ano;
        $gpe_vinculom = Repositories::GPE_VINCULOM;
        $gpe_vinculoh = Repositories::GPE_VINCULOH;
        $gpe_patvinculo = Repositories::GPE_PATVINCULO;
        try {
            $sql = <<<SQL
select count(distinct(pv.nrvinculom)) quant
from $gpe_patvinculo pv
inner join $gpe_vinculom vm
    with vm.nrvinculom = pv.nrvinculom
    and vm.nrorg = pv.nrorg
inner join $gpe_vinculoh vh
    with vm.nrvinculom = vh.nrvinculom
    and vm.nrorg = vh.nrorg
where pv.nrtiposervpat = :nrtiposervpat
    and vm.dtadmissaovinc <= :ultdiano
    and (vm.dtrescisaovinc is null
        or vm.dtrescisaovinc >= :primdiano)
    and vh.nrestrutlegal = :nrestruturam
    and vh.nrorg = :nrorg
    and vh.dtmescompetenc = (select max(mvh.dtmescompetenc)
                                     from $gpe_vinculoh mvh
                                     where mvh.nrvinculom = vh.nrvinculom
                                        and mvh.nrvinculom = vh.nrvinculom
                                        and mvh.dtmescompetenc <= :ultdiano)
SQL;
        $params = array(
            'ultdiano' => $ultdiano,
            'primdiano' => $primdiano,
            'nrestruturam' => $nrestruturam,
            'nrorg' => $nrorg,
            'nrtiposervpat' => $nrtiposervpat
        
        );
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        $result = ($result)?$result[0]:false;
        return ($result)?$result['quant']:$result;

        } catch (\Exception $e) {
            throw $e;
        }

    }
    
    public function getEstruturasRelacionadas($nrorg, $nrestruturamsup, $nrTipoHierarquia = null) {
        if (!empty($nrTipoHierarquia)) {
            $hierarqorg = $this->getEntityManager()->getRepository(Repositories::HIERARQUIAORG)->findBy(array('nrorg' => $nrorg,
            'nrestruturamsup' => $nrestruturamsup, 'nrtipohierarqorg' => $nrTipoHierarquia));
        } else {
            $hierarqorg = $this->getEntityManager()->getRepository(Repositories::HIERARQUIAORG)->findBy(array('nrorg' => $nrorg,
            'nrestruturamsup' => $nrestruturamsup));
        }

       
        if (empty($hierarqorg)) {
            return null;
        }

        $estruturasRelacionadas = array();
        foreach($hierarqorg as $estrutSup){
            $estruturaRelacionada = $this->getEntityManager()->getRepository(Repositories::ESTRUTURAM)->findBy(array('nrorg' => $nrorg,
            'nrestruturam' => $estrutSup->getNrestruturamrel()));
            if (is_object($estruturaRelacionada[0])){
                $estruturasRelacionadas[] = $estruturaRelacionada;
            }
        }

        return $estruturasRelacionadas;
    }
    
}