<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class FpaResumoctbl extends \Doctrine\ORM\EntityRepository {
    
    public function retornaResumoContabilPorEstruturaMesCompetencia($nrorg, $dtocorrencia, $nrestrutura, $nrtipomoviment){
        
        $params = array('nrorg' => $nrorg, 'dtocorrencia' => $dtocorrencia, 'nrestruturam' => $nrestrutura, 'nrtipomoviment' => $nrtipomoviment);
        $fpa_resumoctbl = Repositories::FPA_RESUMOCTBL;
$sql = <<<SQL
    SELECT r FROM $fpa_resumoctbl r
        WHERE r.nrorg = :nrorg
        AND r.dtocorrencia = :dtocorrencia
        AND r.nrestruturam = :nrestruturam
        AND r.nrtipomoviment = :nrtipomoviment
SQL;
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }

    public function retornaResumoContabilPorEstruturaSupMesCompetencia($nrorg, $dtocorrencia, $nrestruturaSup, $nrtipomoviment){
        
        $fpa_resumoctbl = Repositories::FPA_RESUMOCTBL;
        $params = array('nrorg' => $nrorg, 'dtocorrencia' => $dtocorrencia, 'nrestruturamsup' => $nrestruturaSup, 'nrtipomoviment' => $nrtipomoviment);
$sql = <<<SQL
    SELECT r FROM $fpa_resumoctbl r
        WHERE r.nrorg = :nrorg
        AND r.dtocorrencia = :dtocorrencia
        AND r.nrestruturamsup = :nrestruturamsup
        AND r.nrtipomoviment = :nrtipomoviment
SQL;
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }

    public function retornaResumoContabilPorEstruturasMesCompetencia($nrorg, $dtocorrencia, $nrestruturaSup, $nrestrutura, $nrtipomoviment){
        
        $fpa_resumoctbl = Repositories::FPA_RESUMOCTBL;
        $params = array('nrorg' => $nrorg, 'dtocorrencia' => $dtocorrencia, 'nrestruturamsup' => $nrestruturaSup, 'nrestruturam' => $nrestrutura, 'nrtipomoviment' => $nrtipomoviment);
$sql = <<<SQL
    SELECT r FROM $fpa_resumoctbl r
        WHERE r.nrorg = :nrorg
        AND r.dtocorrencia = :dtocorrencia
        AND r.nrestruturamsup = :nrestruturamsup
        AND r.nrestruturam = :nrestruturam
        AND r.nrtipomoviment = :nrtipomoviment
SQL;
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }
    
    public function retornaEventoSemAssociacaoPorSelecaoVinculos(
        $nrorg, $nrorgpadrao, $dtmescompetenc, $nrcalculofolha, $condIntervalo = '', $condAtivos = ''
    ){
        $fpa_eventom = Repositories::FPA_EVENTOM;
        $fpa_eventoh = Repositories::FPA_EVENTOH;
        $fpa_itecalc = Repositories::FPA_ITECALCFOLHA;
        $gpe_vinculom = Repositories::GPE_VINCULOM;
        $gpe_vinculoh = Repositories::GPE_VINCULOH;
        $fpa_eventoctbl = Repositories::FPA_EVENTOCTBL;
        $estruturam = Repositories::ESTRUTURAM;
        
	    $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtmescompetenc));
$sql = <<<SQL
select distinct esm.nmestruturam, vh.nrestrutlegal, em.nreventom, eh.nmeventoh
                  from $fpa_eventom em
                  join $fpa_eventoh eh WITH eh.nrorg = em.nrorg
                                     and eh.nreventom = em.nreventom
                                     and eh.dtmescompetenc = (select max(h1.dtmescompetenc)
                                                                from $fpa_eventoh h1
                                                               where h1.nrorg = eh.nrorg
                                                                 and h1.nreventom = eh.nreventom
                                                                 and h1.dtmescompetenc <= :p_dtmescompetenc)
                  join $fpa_itecalc ic WITH ic.nrorg = :p_nrorg
                                          and ic.nreventom = em.nreventom
                  join $gpe_vinculom vm WITH vm.nrorg = ic.nrorg
                                      and vm.nrvinculom = ic.nrvinculom
                  join $gpe_vinculoh vh WITH vh.nrorg = vm.nrorg
                                      and vh.nrvinculom = vm.nrvinculom
                                      and vh.dtmescompetenc = (select max(hh1.dtmescompetenc)
                                                                           from $gpe_vinculoh hh1
                                                                          where hh1.nrorg = vh.nrorg
                                                                            and hh1.nrvinculom = vh.nrvinculom
                                                                            and hh1.dtmescompetenc <= :p_dtmescompetenc)
                 left join $estruturam esm WITH esm.nrorg = ic.nrorg AND esm.nrestruturam = vh.nrestrutlegal
                 where (em.nrorg = :p_nrorg or em.nrorg = :p_nrorgpadrao)
                   and em.idtipoevento in ('PROVENTO','DESCONTO','ENCARGO')
                   and ic.idevendemoncalc = 'N'
                   and ic.nrcalculofolha = :p_nrcalculofolha
				   and em.nreventom not in (2100, 2110, 2030, 2120, 2130, 2140, 2150)
                   and em.nreventom not in (select ec.nreventom
                                              from $fpa_eventoctbl ec
                                             where ec.nrorg = vh.nrorg
                                               and (ec.nrestruturam = vh.nrestrutlegal or ec.nrestruturam is null)
                                               and ec.dtinivigencia <= :p_dtmescompetenc
                                               and ec.nreventom = ic.nreventom)
                   $condIntervalo
                   $condAtivos
                 order by vh.nrestrutlegal, em.nreventom
SQL;
        $params = array(
            'p_nrorg' => $nrorg,
            'p_nrorgpadrao' => $nrorgpadrao,
            'p_dtmescompetenc' => $dtmescompetenc,
            'p_nrcalculofolha' => $nrcalculofolha,
            'p_dtultdiames' => $dtUltDiaMes
        );
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);

        return $resultado;
    }
    
}