(function() {
    var BASE_DIR_THEME     = 'bower_components/zeedhi-frontend/assets/css/styles/';
    var STYLESHEET_TYPE    = 'stylesheet';
    var SHORTCUT_ICON_TYPE = 'shortcut icon';
    var BASE_DIR_IMAGES    = '../../../mobile/assets/images/';
    if(window.openLoginContainerWithoutRedirect) {
        BASE_DIR_IMAGES    = './assets/images/';
    }

    var addLinkTagInHead = function(href, type) {
        var lnk = document.createElement('link');
        lnk.setAttribute('rel', type );
        if(type == STYLESHEET_TYPE) {
            lnk.setAttribute('type', 'text/css');
        }
        lnk.setAttribute('href', href);
        document.getElementsByTagName('head').item(0).appendChild(lnk);
    };

    //Update Theme
    var style = window.cssStyle || 'inflightor';
    var href = BASE_DIR_THEME + 'styles-' + style + '.css';
    addLinkTagInHead(href, STYLESHEET_TYPE);

    //Update Favicon
    var favicon = BASE_DIR_IMAGES + 'favicon.png';
    addLinkTagInHead(favicon, SHORTCUT_ICON_TYPE);

    //Set Logo Image
    window.logoImage = BASE_DIR_IMAGES + 'logo.png';

    if(window.location.hash.replace('#/', '') == 'login#authentication') {
        //Update Splash
        var splash = BASE_DIR_IMAGES + 'splash.svg';
        $("<style> .splash { background-image: url(" + splash + "); }</style>").appendTo("head");
    } else if(!window.notRemoveSplash){
        //Remove Splash
        $("<style> .splash { display: none !important; }</style>").appendTo("head");
    }
}) ();