<?php

namespace Teknisa\ACL\Repositories;

use Doctrine\DBAL\Connection;
use Teknisa\ACL\Util\InstanceProvider;

class PerfAcessParc {

    const QUERY_MAX_NR_PERF_ACESS_PARC = "SELECT MAX(NRPERFACESSPARC) as MAXNRPERFACESSPARC FROM PERFACESSPARC";

    /** @var Connection */
    protected $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function getMaxNrPerfAcessParc () {
        return $this->connection->fetchAll(self::QUERY_MAX_NR_PERF_ACESS_PARC);
    }

    public function deleteAssociatedPerfAcessParc (Array $nrPerfilAcesso, Array $params) {
        $profilesToDelete = implode(',', $nrPerfilAcesso);
        $sqlDeletePerfParc = "DELETE FROM PERFACESSPARC WHERE NRPERFILACESSO IN (".$profilesToDelete.")";
        return $this->connection->executeQuery($sqlDeletePerfParc, $params);
    }

    public function findPerfAcessParcOperador($filters, $order)
    {
        $query = <<<SQL
            SELECT CDOPERADOR, NMOPERADOR, NRPERFACESSPARC, NRORG, NRPARCNEGOCIO,
                           NRPERFILACESSO, IDATIVO, TO_CHAR(DTVALIDADE, 'DD/MM/YYYY') AS DTVALIDADE
              FROM (SELECT O.CDOPERADOR, O.NMOPERADOR, P.NRPERFACESSPARC, P.NRORG, P.NRPARCNEGOCIO,
                           P.NRPERFILACESSO, P.IDATIVO, P.DTVALIDADE
                      FROM PERFACESSPARC P
                      JOIN OPERADOR O ON (P.NRPARCNEGOCIO = O.NRPARCNEGOCIO AND P.NRORG = O.NRORG)
                     )
              WHERE 1 = 1
              $filters
              $order
SQL;
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);
    }

}